<?php

    /*
    PHP Based iTunes Library Browser
    Copyright (C) 2007  Jason Barrie Morley
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
    */
    
    include("tables.php");
    include("settings.php");
    
    function iTunesConnect() {
        
        // Attempt to open a connection to the database.
        global $databaseUser, $databasePass, $databaseName, $databasePrefix, $databaseHost, $iTunesXML;
        mysql_connect($databaseHost, $databaseUser, $databasePass);
        mysql_select_db($databaseName);
        
    }
    
    function iTunesInitialize() {
    
        global $databaseUser, $databasePass, $databaseName, $databasePrefix, $databaseHost, $iTunesXML;
        
        // Initially, create the database if it does not exist.
        $sqlTableMusic = "CREATE TABLE IF NOT EXISTS `".$databasePrefix."music` ( `id` int(11) NOT NULL auto_increment, `name` varchar(255) NOT NULL default '', `artist` varchar(255) NOT NULL default '', `album` varchar(255) NOT NULL default '', `genre` varchar(255) NOT NULL default '', `rating` int(11) NOT NULL default '0',  PRIMARY KEY  (`id`) ) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=3789 ;";
        $sqlTableMeta = "CREATE TABLE IF NOT EXISTS `".$databasePrefix."meta` ( `id` int(11) NOT NULL auto_increment, `key` varchar(255) NOT NULL default '', `value` varchar(255) NOT NULL default '', PRIMARY KEY  (`id`)) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";
        $result = mysql_query($sqlTableMusic);
        $result = mysql_query($sqlTableMeta);
        
        // First, work out the md5 of the data.
        $md5 = shell_exec("md5sum $iTunesXML");
        
        // Compare to the previous md5sum and only update the database if it has changed.
        $sql = "SELECT * FROM ".$databasePrefix."meta WHERE `key`='md5';";
        $result = mysql_query($sql);
        
        if (mysql_num_rows($result) == 0 || $md5 != mysql_result($result, 0, "value")) {
        
            mysql_query("TRUNCATE TABLE `".$databasePrefix."music`;");
            
            $handle = fopen($iTunesXML, "r");
            $lines = file($iTunesXML); //$lines is an array
            
            $field_name = ""; $field_artist = ""; $field_album = ""; $field_genre = ""; $field_rating = "";
                    
            for($i = 0; $i < sizeof($lines); $i++) {
            
                if (preg_match("/<key>(.+)<\/key><(.+)>(.+)<\/(.+)>/", $lines[$i], $matches)) {
                
                    if ($matches[1] == "Name") {
                    
                        addRow($field_name, $field_artist, $field_album, $field_genre, $field_rating);
        
                        $field_name = "";
                        $field_artist = "";
                        $field_album = "";
                        $field_genre = "";
                        $field_rating = "";
                        
                        $field_name = $matches[3];
                    
                    } elseif ($matches[1] == "Artist") {
                        $field_artist = $matches[3];
                    } elseif ($matches[1] == "Album") {
                        $field_album = $matches[3];
                    } elseif ($matches[1] == "Genre") {
                        $field_genre = $matches[3];
                    } elseif ($matches[1] == "Rating") {
                        $field_rating = $matches[3];
                    }
                    
                }
                
            }
            
            // Deal with the last row.
            addRow($field_name, $field_artist, $field_album, $field_genre, $field_rating);
    
            // Update the database with the new hash.
            mysql_query("DELETE FROM `".$databasePrefix."meta` WHERE `key` = 'md5' LIMIT 1");
            mysql_query("INSERT INTO  `".$databasePrefix."meta` ( `key` ,  `value` ) VALUES ( 'md5',  '".$md5."' );");
    
        }
        
    }
    
    function iTunesDisplay() {
    
        global $databasePrefix;
    
        RenderTable($databasePrefix."music",
                    "1",
                    array(
                        $databasePrefix."music.id" => array(""),
                        $databasePrefix."music.name" => array("Name"),
                        $databasePrefix."music.artist" => array("Artist"),
                        $databasePrefix."music.album" => array("Album"),
                        $databasePrefix."music.genre" => array("Genre"),
                        $databasePrefix."music.rating" => array("Rating", "Stars"),
                        ),
                    30,
                    1,
                    0,
                    false,
                "Last",
                false,
                "<img src='images/clear.gif' />"
                    );	
        
    }
    
    function Stars($string, $fields) {
        if ($fields[$databasePrefix."music.rating"] == 0) {
            return "";
        } else {
            return "<img src='images/rating".$fields[$databasePrefix."music.rating"].".gif' />";
        }
    }
    
    function Last($fields) {
        global $databasePrefix;
        $artist = $fields[$databasePrefix."music.artist"];
        $artist = preg_replace('/\s+/', "+", $artist);
        $track = $fields[$databasePrefix."music.name"];
        $track = preg_replace('/\s+/', "+", $track);
        return "http://www.last.fm/music/".$artist."/_/".$track;
    }
    
    function addRow($name, $artist, $album, $genre, $rating) {
        if ($name != "") {
        global $databasePrefix;
            if ($rating == "") { $rating = 0; } // Correct the rating.
            $sql = "INSERT INTO `".$databasePrefix."music` (`name`, `artist`, `album`, `genre`, `rating`) VALUES ('$name', '$artist', '$album', '$genre', $rating);";
            $result = mysql_query($sql);
        }
    }
            

?>